#ifndef _ADDORNAMENT_CPP_
#define _ADDORNAMENT_CPP_

#include <iostream.h>

#include "addOrnament.h"
#include "ornament.h"
#include "compound.h"

#include "track.h"
#include "song.h"
#include "note.h"

extern Song * sonG;

AddOrnament::AddOrnament(Ornament * o, Note * note) : _ornament(o), _note(note) {
  _type = ADDORNAMENT;
  _description = "add ornament";
  _to_be_undone = true;
  if (note) {
    note->add(o);
  }
}

AddOrnament::AddOrnament(AddOrnament * o) {
  _type = ADDORNAMENT;
  _ornament = o->_ornament;
  _note = o->_note;
}

AddOrnament::~AddOrnament() {
  delete _ornament;
}

void AddOrnament::undo() {
  if (_note) {
    _note->remove(_ornament);
  }
}

void AddOrnament::redo() {
  if (_note) {
    _note->add(_ornament);
  }
}



// ---------------
// virtuals:
//

ostream & AddOrnament::print(int dep, ostream & s) {
  s << spc(dep) << "<ADDORNAMENT ornament=\"" << _ornament->ctype() << "\" compound=\"" << _note->ctype() << "\" />" << endl;
  return s;
}

void AddOrnament::flush(char * c) {
  cout << c << "ADDORNAMENT" << endl;
}

Element * AddOrnament::copy() {
  return new AddOrnament(this);
}

  


#endif
