#ifndef _ADDSYMBOL_CPP_
#define _ADDSYMBOL_CPP_

#include <iostream.h>

#include "addSymbol.h"
#include "symbol.h"
#include "compound.h"

#include "track.h"
#include "song.h"
#include "part.h"

extern Song * sonG;

AddSymbol::AddSymbol(Symbol * o, Part * part) : _symbol(o), _part(part) {
  _type = ADDSYMBOL;
  _description = "add symbol";
  _to_be_undone = true;
  if (part) {
    part->add(o);
  }
}

AddSymbol::AddSymbol(AddSymbol * o) {
  _type = ADDSYMBOL;
  _symbol = o->_symbol;
  _part = o->_part;
}

AddSymbol::~AddSymbol() {
  delete _symbol;
}

void AddSymbol::undo() {
  if (_part) {
    _part->remove(_symbol);
  }
}

void AddSymbol::redo() {
  if (_part) {
    _part->add(_symbol);
  }
}



// ---------------
// virtuals:
//

ostream & AddSymbol::print(int dep, ostream & s) {
  s << spc(dep) << "<ADDSYMBOL symbol=\"" << _symbol->ctype() << "\" compound=\"" << _part->ctype() << "\" />" << endl;
  return s;
}

void AddSymbol::flush(char * c) {
  cout << c << "ADDSYMBOL" << endl;
}

Element * AddSymbol::copy() {
  return new AddSymbol(this);
}

  


#endif
