#ifndef _DUMP_CPP_
#define _DUMP_CPP_

#include <iostream.h>

#include <reference.h>
#include <table.h>
#include <event.h>
#include <part.h>
#include <track.h>
#include <song.h>
#include <str.h>

#include "dump.h"

extern Table * selectioN;
extern Table * selectionMemory;

// #define DUMP_CONTEXT Addon::TREAT_SELECTION + Addon::TREAT_TRACK + Addon::TREAT_PART + Addon::TREAT_SONG
#define DUMP_CONTEXT Addon::TREAT_ALL

extern "C" {
  Addon * dump(Element * target) { return new Dump(target); }
  char  * dump_name()     { return "dump"; }
  char  * dump_category() { return "testing"; }
  int     dump_context() { return DUMP_CONTEXT; }
}


Dump::Dump(Element * target) : Addon("dump element", target, !TO_BE_UNDONE, DUMP_CONTEXT) { run(); }

Dump::~Dump() {

}

void Dump::selection(Table * selection) {
  cout << "contents of the current selection:\n" << endl;
  for (Reference * r = (Reference*)selection->first(); r != 0; r = (Reference*) Element::next(r)) {
    Event * ev = (Event*) r->getValue();
    cout << *ev << endl;
  }
  cout << "--------\ncontents of the current memory:\n" << endl;
  for (Reference * r = (Reference*)selectionMemory->first(); r != 0; r = (Reference*) Element::next(r)) {
    Event * ev = (Event*) r->getValue();
    cout << *ev << endl;
  }
  cout << "---------------------------------------------\n" << endl;
}
void Dump::part(Part * part) {
  cout << "contents of this part:\n" << endl;
  for (Event * ev = (Event*)part->first(); ev != 0; ev = (Event*) Element::next(ev)) {
    cout << *ev << endl;
  }
  cout << "---------------------------------------------\n" << endl;
}
void Dump::track(Track * track) {
  cout << "contents of track: ";
  cout << track->name()->getValue() << ":\n" << endl;
  int sz = track->size();
  for (int i=0; i<sz; i++) {
    Part * pt = (Part*) track->get(i);
    for (Event * ev = (Event*) pt->first(); ev != 0; ev = (Event*) Element::next(ev)) {
      cout << i << ": " << *ev << endl;
    }
  }
  cout << "---------------------------------------------\n" << endl;
}

void Dump::song(Song * song) {
  cout << "contents of song ";
  cout << song->title() << ":\n" << endl;
  int sz = song->size();
  for (int i=0; i<sz; i++) {
    Track * tr = (Track*) song->get(i);
    cout << "Track: " << tr->name()->getValue() << endl;
  }  
  cout << "---------------------------------------------\n" << endl;
}

void Dump::undo() {
}

void Dump::redo() {
}






#endif
