#ifndef _ATOMA_H_
#define _ATOMA_H_

#include "element.h"

class ostream;

/** Classes derived from class Atoma do not contain further elements (in a canonical way - the class Note contains
 *  a table of elements as a data member). Atomas are can be printed and copied. (This class was originally of course
 *  called Atom, but this conflicted with class kapp.h
 */
class Atoma : public Element
{
 private:

 public:
  
  /** Default constructor */
  Atoma() {};

  /** Constructor used by copy() */
  Atoma(Atoma*,Type);

  /** overload this destructor to free memory! */
  virtual ~Atoma();

  /** print has to be implemented */
  virtual ostream & print(int,ostream&)=0;

  /** flush has to be implemented */
  virtual void flush(char*)=0;

  /** copy has to be implemented */
  virtual Element * copy()=0;

  virtual bool isTrack() { return false; }
};

#endif
