#ifndef _AUDIOTRACK_CPP_
#define _AUDIOTRACK_CPP_

#include <iostream.h>
#include "audioTrack.h"
#include "loader.h"
#include "table.h"
#include "str.h"
#include "prTrack.h"
#include "prFactory.h"

extern PrFactory * factory;


AudioTrack::AudioTrack()
{
  _type = AUDIOTRACK;
  _pr = factory->createAudioTrack(this);
}

AudioTrack::AudioTrack(AudioTrack * st)
  : Track(st,AUDIOTRACK)
{
  if (st) {
    _pr = factory->createAudioTrack(this);
  }
}

AudioTrack::~AudioTrack() {
}

ostream & AudioTrack::printOptions(int dep, ostream & s) {
  s << spc(dep) << "<OPTIONS ";
  s << " file=\"" << _file << "\"";
  s << " />" << endl;
}

void AudioTrack::flush(char * c) {
  cout << c << "AUDIOTRACK" << endl;
}

Element * AudioTrack::copy() {
  return new AudioTrack(this);
}

void AudioTrack::loadOpt(ifstream *& inPtr) {
  Table * opt = Loader::getAttributes("OPTIONS",inPtr);
  
  opt->scratch();
  delete opt;
}


#endif
