#ifndef _BOW_CPP_
#define _BOW_CPP_

#include <iostream.h>
#include "bow.h"

Bow::Bow() { _type = BOW; }

Bow::Bow(int l) : _length(l) { _type = BOW; }

Bow::Bow(int l, int d) : _length(l), _direction(d) { _type = BOW; }

Bow::Bow(int l, int d, int dd) : _length(l), _direction(d), _delta(dd) { _type = BOW; }

Bow::Bow(Bow * o) {
  _type = BOW;
}

void Bow::flip() {
  if (_direction==UP) _direction = DOWN;
  else _direction = UP;
}

int Bow::length() { return _length; }

int Bow::direction() { return _direction; }

bool Bow::up() { return (_direction==UP); }

bool Bow::down() { return (_direction==DOWN); }

int Bow::delta() { return _delta; }

void Bow::setLength(int l) { _length = l; }

void Bow::setDirection(int d) { _direction = d; }

void Bow::setUp() { _direction = UP; }

void Bow::setDown() { _direction = DOWN; }

void Bow::setDelta(int d) { _delta = d; }




// virtuals:


ostream & Bow::print(int dep, ostream & s) {
  s << spc(dep) << "<BOW length=\"" << _length << "\" direction=\"";
  switch (_direction) {
  case UP: s << "UP"; break;
  case DOWN: s << "DOWN"; break;
  }
  s << "\" delta=\"" << _delta << "\" />" << endl;
  return s;
}

void Bow::flush(char * c) {
  cout << c << "BOW " << _length << ", " << _direction << ", " << _delta << endl;

}

Element * Bow::copy() {
  return new Bow(this);
}



#endif
