#ifndef _COMMENTTRACK_CPP_
#define _COMMENTTRACK_CPP_

#include <iostream.h>
#include "commentTrack.h"
#include "loader.h"
#include "table.h"
#include "str.h"
#include "prTrack.h"
#include "prFactory.h"
#include "song.h"

extern Song * sonG;
extern PrFactory * factory;


CommentTrack::CommentTrack()
{
  _type = COMMENTTRACK;
  _pr = factory->createCommentTrack(this);
}

CommentTrack::CommentTrack(CommentTrack * st)
  : Track(st,COMMENTTRACK)
{
  if (st) {
    _pr = factory->createCommentTrack(this);
  }
}

CommentTrack::~CommentTrack() {
}

ostream & CommentTrack::printOptions(int dep, ostream & s) {
  s << spc(dep) << "<OPTIONS ";

  s << " />" << endl;
}

void CommentTrack::flush(char * c) {
  cout << c << "COMMENTTRACK" << endl;
}

Element * CommentTrack::copy() {
  return new CommentTrack(this);
}

void CommentTrack::loadOpt(ifstream *& inPtr) {
  Table * opt = Loader::getAttributes("OPTIONS",inPtr);
  
  opt->scratch();
  delete opt;
}


#endif
