#ifndef _DRUMTRACK_CPP_
#define _DRUMTRACK_CPP_

#include <iostream.h>
#include "drumTrack.h"
#include "loader.h"
#include "table.h"
#include "str.h"
#include "prTrack.h"
#include "prFactory.h"

extern PrFactory * factory;

DrumTrack::DrumTrack()
  : _channel(0), _program(0), _output(0), _volume(0), _delay(0), _transpose(0)
{
  _type = DRUMTRACK;
  _pr = factory->createDrumTrack(this);
}

DrumTrack::DrumTrack(DrumTrack * st)
  : Track(st,DRUMTRACK)
{
  if (st) {
    _channel = st->channel();
    _program = st->program();
    _output = st->output();
    _volume = st->volume();
    _delay = st->delay();
    _transpose = st->transpose();
    _pr = factory->createDrumTrack(this);
  }
}


DrumTrack::~DrumTrack() {
}

int DrumTrack::channel() {
  return _channel;
}

int DrumTrack::program() {
  return _program;
}

int DrumTrack::output() {
  return _output;
}

int DrumTrack::volume() {
  return _volume;
}

int DrumTrack::delay() {
  return _delay;
}

int DrumTrack::transpose() {
  return _transpose;
}


void DrumTrack::setChannel(int i) {
  _channel = i;
}

void DrumTrack::setProgram(int i) {
  _program = i;
}

void DrumTrack::setOutput(int i) {
  _output = i;
}

void DrumTrack::setVolume(int i) {
  _volume = i;
}

void DrumTrack::setDelay(int i) {
  _delay = i;
}

void DrumTrack::setTranspose(int i) {
  _transpose = i;
}



ostream & DrumTrack::printOptions(int dep, ostream & s) {
  s << spc(dep) << "<OPTIONS ";
  s << " program=\"" << _program << "\"";
  s << " channel=\"" << _channel << "\"";
  s << " output=\"" << _output << "\"";
  s << " volume=\"" << _volume << "\"";
  s << " transpose=\"" << _transpose << "\"";
  s << " delay=\"" << _delay << "\"";
  // s << " print=\"" << str->PiP() << "\"";
  // s << " printps=\"" << str->PiPS() << "\"";
  s << " />" << endl;
}

void DrumTrack::flush(char * c) {
  cout << c << "DRUMTRACK" << endl;
}

Element * DrumTrack::copy() {
  return new DrumTrack(this);
}

void DrumTrack::loadOpt(ifstream *& inPtr) {
  Table * opt = Loader::getAttributes("OPTIONS",inPtr);

  opt->scratch();
  delete opt;
}


#endif
