#ifndef _EVENT_CPP_
#define _EVENT_CPP_

#include "event.h"

Event::Event() : _pos(0), _len(0) { _type = EVENT; }

Event::Event(Event * e) : _pos(0), _len(0) {
  _type = EVENT;
  if (e) {
    _pos = e->start().ticks();
    _len = e->length();
  }
}

Event::Event(Position p) : _pos(p), _len(0) { _type = EVENT; }

Event::Event(Position p, long l) : _pos(p), _len(l) { _type = EVENT; }


Position & Event::start() {
  // so geht es seltsamerweise:
  return _pos;
}


long Event::end() {
  // Position * p = new Position(_pos+_len);
  // return *p;
  long x = _pos.ticks();
  x += _len;
  return x;
}

long Event::length() { return _len; }

void Event::setStart(Position pos) {
  _pos = pos;
}

void Event::snapStart(int i) {
  _pos.snap(i);
}

void Event::setLength(long l) {
  _len = l;
}

bool Event::startsBefore(long l) {
  return (_pos.ticks()<l);
}

bool Event::startsBehind(long l) {
  return (_pos.ticks()>l);
}

bool Event::startsAt(long l) {
  return (_pos.ticks()==l);
}

bool Event::endsBefore(long l) {
  return (_pos.ticks()+_len<l);
}

bool Event::endsBehind(long l) {
  return (_pos.ticks()+_len>l);
}

bool Event::endsAt(long l) {
  return (_pos.ticks()+_len==l);
}

#endif
