#ifndef _GLUEPARTS_CPP_
#define _GLUEPARTS_CPP_

#include <iostream.h>

#include "glueParts.h"
#include "element.h"
#include "compound.h"

#include "event.h"
#include "part.h"
#include "track.h"
#include "song.h"
extern Song * sonG;

GlueParts::GlueParts(Part * pt) : _part(pt), _lost(0) {
  _type = GLUEPARTS;
  _description = "glue parts";
  _to_be_undone = true;
  if (_part) {
    Part * pt2 = (Part*) _part->next(_part);
    if (pt2!=0) {
      _relpos = pt2->start()-_part->start();
      _lost = _part->partGlue();
      _lost->hide();
    }
  }
}

GlueParts::GlueParts(GlueParts * el) {
  _type = GLUEPARTS;
  _part = el->_part;
  _relpos = el->_relpos;
  _lost = el->_lost;
}

GlueParts::~GlueParts() {
  if (_lost != 0) delete _lost;
}

void GlueParts::undo() {
  Event * newstart = _part->partSplit(_relpos);
  if (newstart!=0) {
    // Part * _newpart = new Part(_part->track());
    Position offset = newstart->start() + _part->start();
    _lost->setStart(offset);
    _lost->show();
    for (Event * ev = newstart; ev != 0; ev = (Event*) _lost->next(ev))
      ev->setStart(ev->start() - offset);
    _lost->setContent(newstart);
    _part->track()->add(_lost);
  }
  _lost = 0;
}

void GlueParts::redo() {
  if (_part) {
    Part * pt2 = (Part*) _part->next(_part);
    if (pt2!=0) {
      _relpos = pt2->start()-_part->start();
      _lost = _part->partGlue();
      _lost->hide();
    }
  }
}



// ---------------
// virtuals:
//

ostream & GlueParts::print(int dep, ostream & s) {
  s << spc(dep) << "<GLUEPARTS part=\"" << _part << "\" relpos=\"" << _relpos << "\" />" << endl;
  return s;
}

void GlueParts::flush(char * c) {
  cout << c << "GLUEPARTS" << endl;
}

Element * GlueParts::copy() {
  return new GlueParts(this);
}

  


#endif
