#ifndef _MAIN_CPP_
#define _MAIN_CPP_

#include <dlfcn.h>
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "addElement.h"
#include "element.h"
#include "song.h"
#include "track.h"
#include "part.h"
#include "prFactory.h"
#include "vector.h"
#include "note.h"
#include "prMainEditor.h"
#include "reference.h"
#include "scoreTrack.h"
#include "str.h"
#include "table.h"

typedef PrFactory * (*FactoryFunction)();


Song * sonG = 0;
Table * selectioN = 0;
Table * selectionMemory = 0;
PrFactory * factory = 0;
PrMainEditor * mainEditor = 0;


char * parameter(const char * name, const char * alt, int argc, char ** argv) {
  char * ret = 0;
  for (int i=0; i<argc; i++) {
    if ((strcmp(argv[i],name)==0)||(strcmp(argv[i],alt)==0)) { if (strcmp(name,"--help")!=0) { ret = strdup(argv[i+1]); } }
    continue;
  }
  return ret;
}


main(int argc, char ** argv) {
  
  if (parameter("--help","-h",argc,argv)) {
    cout << "usage: " << argv[0] << " [-p|--presentation text|kde|<LIBRARY-NAME>] [-a|--addon <MODULENAME>]* [-f|--file <BRAHMS-FILE>]" << endl;
    cout << "or: " << argv[0] << " [-h|--help]" << endl;
  } else {
  
  char * DLERROR;
  char * presentation = parameter("--presentation", "-p",argc,argv);
  
  selectioN = new Table();
  selectionMemory = new Table();

  if (presentation==NULL) {
    cout << "error: Specify a presentation (text|kde|qt)" << endl;
    exit(1);
  }

  // rename shortcuts
  if (strcmp(presentation,"text")==0) { presentation = strdup("libBrahmsTextPresentation"); }
  else if (strcmp(presentation,"kde")==0) { presentation = strdup("libBrahmsKdePresentation"); }
  else if (strcmp(presentation,"qt")==0) { presentation = strdup("libBrahmsQtPresentation"); }
  
  int plen = strlen(presentation);
  char * fname = new char[plen+4];
  sprintf(fname,"%s.so\0",presentation);

#ifdef DEBUGIT
  cout << "trying to open library " << "libBrahmsCore.so" << " ..." << endl;
#endif
  void * handleCore = dlopen ("libBrahmsCore.so", RTLD_NOW | RTLD_GLOBAL);
  if (!handleCore) {
    cout << "error open core: " << dlerror() << endl;
    exit(1);
  }

  // DOIT: Get libBrahmsKdePresentation linked to qt and kde automatically in Makefile of kde-presentation!
  if (strcmp(fname,"libBrahmsKdePresentation.so")==0) {
#ifdef DEBUGIT
    cout << "trying to open library " << "/usr/lib/qt/lib/libqt.so" << " ..." << endl;
#endif
    void * handleQt = dlopen ("/usr/lib/qt/lib/libqt.so", RTLD_NOW | RTLD_GLOBAL);
    if (!handleQt) { cout << "error open core: " << dlerror() << endl; exit(1); }
#ifdef DEBUGIT
    cout << "trying to open kde libraries " << endl;
#endif
    void * handleKDE0 = dlopen ("/opt/kde2/lib/libDCOP.so.1", RTLD_NOW | RTLD_GLOBAL);
    if (!handleKDE0) { cout << "error open dcop: " << dlerror() << endl; exit(1); }
    void * handleKDE1 = dlopen ("/opt/kde2/lib/libkdecore.so", RTLD_LAZY | RTLD_GLOBAL);
    if (!handleKDE1) { cout << "error open core: " << dlerror() << endl; exit(1); }
    void * handleKDE2 = dlopen ("/opt/kde2/lib/libkdeui.so", RTLD_LAZY | RTLD_GLOBAL);
    if (!handleKDE2) { cout << "error open gui: " << dlerror() << endl; exit(1); }
    void * handleKDE4 = dlopen ("/opt/kde2/lib/libkio.so", RTLD_LAZY | RTLD_GLOBAL);
    if (!handleKDE4) { cout << "error open kio: " << dlerror() << endl; exit(1); }
    void * handleKDE3 = dlopen ("/opt/kde2/lib/libksycoca.so", RTLD_LAZY | RTLD_GLOBAL);
    if (!handleKDE3) { cout << "error open sycoca: " << dlerror() << endl; exit(1); }
    void * handleKDE5 = dlopen ("/opt/kde2/lib/libkfile.so", RTLD_LAZY | RTLD_GLOBAL);
    if (!handleKDE5) { cout << "error open libkfile: " << dlerror() << endl; exit(1); }
  }

#ifdef DEBUGIT
  cout << "trying to open library " << fname << " ..." << endl;
#endif
  void * handle = dlopen (fname, RTLD_LAZY | RTLD_GLOBAL );
  if (!handle) {
    cout << "error open presentation: " << dlerror() << endl;
    exit(1);
  }
  
#ifdef DEBUGIT
  cout << "trying to get symbol " << presentation << " ..." << endl;
#endif
  FactoryFunction getFactory = (FactoryFunction) dlsym(handle,presentation);
  if ((DLERROR = dlerror()) != NULL)  {
    cout << "error sym: " << DLERROR << endl;
    exit(1);
  }
  factory = getFactory();
  
#ifdef DEBUGIT
  cout << factory->isA() << endl;
#endif
  
  mainEditor = factory->createMainEditor(argc,argv);
    
  mainEditor->run();
  dlclose(handle);


  
  }

}


#endif
