#ifndef _MASTEREVENT_CPP_
#define _MASTEREVENT_CPP_

#include <iostream.h>
#include "masterEvent.h"
#include "event.h"

MasterEvent::MasterEvent( ) { _type = MASTEREVENT; }

MasterEvent::MasterEvent(MasterEvent * m) : Event(m) {
  _type = MASTEREVENT;
  if (m) {
    _tempo = m->tempo();
    _meter0 = m->meter0();
    _meter1 = m->meter1();
  }
}

MasterEvent::MasterEvent(Position pos, int tempo)
  : Event(pos,0), _tempo(tempo), _meter0(0), _meter1(0) {
}

MasterEvent::MasterEvent(Position pos, int met0, int met1)
  : Event(pos,0), _tempo(0), _meter0(met0), _meter1(met1) {
}

MasterEvent::MasterEvent(Position pos, int tempo, int met0, int met1)
  : Event(pos,0), _tempo(tempo), _meter0(met0), _meter1(met1) {
}


int MasterEvent::tempo() { return _tempo; }

int MasterEvent::meter0() { return _meter0; }

int MasterEvent::meter1() { return _meter1; }

void MasterEvent::setTempo(int tempo) { _tempo = tempo; }

void MasterEvent::setMeter0(int met0) { _meter0 = met0; }

void MasterEvent::setMeter1(int met1) { _meter1 = met1; }



ostream & MasterEvent::print(int dep, ostream & s) {
  s << spc(dep) << "<MASTEREVENT pos=\"" << start().ticks() << "\"";
  if (_tempo>0) s << " tempo=\"" << _tempo << "\"";
  if (_meter1>0) s << " meter0=\"" << _meter0 << "\" meter1=\"" << _meter1 << "\"";
  s << " />" << endl;
  return s;
}

void MasterEvent::flush(char * c) {
  cout << c << "MASTEREVENT" << endl;
}

Element * MasterEvent::copy() {
  return new MasterEvent(this);
}



#endif
