#ifndef _MIDIEVENT_CPP_
#define _MIDIEVENT_CPP_

#include <iostream.h>

#include "midiEvent.h"



MidiEvent::MidiEvent(MidiEvent * m) : Event(m) {
  _type = MIDIEVENT;
  if (m) {
    _codechan = m->codeAndChannel();
    _value1 = m->value1();
    _value2 = m->value2();
  }
}

MidiEvent::MidiEvent(Position pos, int cc, int value1, int value2)
  : Event(pos,0), _codechan(cc), _value1(value1), _value2(value2) {
  _type = MIDIEVENT;
}



int MidiEvent::code() { return int((_codechan&240)/16); }

int MidiEvent::channel() { return int(_codechan&15); }

int MidiEvent::codeAndChannel() { return _codechan; }

int MidiEvent::value1() { return _value1; }

int MidiEvent::value2() { return _value2; }

void MidiEvent::setCodeAndChannel(int cc) { _codechan = cc; }

void MidiEvent::setValue1(int met0) { _value1 = met0; }

void MidiEvent::setValue2(int met1) { _value2 = met1; }



ostream & MidiEvent::print(int dep, ostream & s) {
  s << spc(dep) << "<MIDIEVENT pos=\"" << start().ticks() << "\" code=\"" << _codechan << "\" value1=\"" << _value1 << "\" value2=\"" << _value2 << "\" />" << endl;
  return s;
}

void MidiEvent::flush(char * c) {
  cout << c << "MIDIEVENT" << endl;
}

Element * MidiEvent::copy() {
  return new MidiEvent(this);
}






#endif
