#ifndef _MIDIEVENT_H_
#define _MIDIEVENT_H_

#include "event.h"

/** Instances of this class are midievents. They do not need a (graphical) presentation of their own. They can be displayed
 * graphically within the presentation of the parts, they belong to.
**/

class MidiEvent : public Event
{
 private:
  int _codechan;
  int _value1;
  int _value2;

 public:
  MidiEvent( );
  MidiEvent(MidiEvent*);
  MidiEvent(Position pos, int cc, int value1, int value2=0);
  
  int code();
  int channel();
  int codeAndChannel();
  int value1();
  int value2();
  void setCodeAndChannel(int);
  void setValue1(int);
  void setValue2(int);
  
  virtual ostream & print(int,ostream&);
  virtual void flush(char*);
  virtual Element * copy();
};


#endif
