#ifndef _MOVEPART_CPP_
#define _MOVEPART_CPP_

#include <iostream.h>

#include "movePart.h"
#include "element.h"
#include "compound.h"

#include "part.h"
#include "track.h"
#include "song.h"
extern Song * sonG;

MovePart::MovePart(Position p, Part * pt) : _part(pt), _old(pt->start()), _new(p) {
  _type = MOVEPART;
  _description = "move part";
  _to_be_undone = true;
  if (_part) {
    _part->setStart(_new);
  }
}

MovePart::MovePart(MovePart * el) {
  _type = MOVEPART;
  _part = el->_part;
  _old = el->_old;
  _new = el->_new;
}

MovePart::~MovePart() {
}

void MovePart::undo() {
  if (_part) {
cout << "old: " << _old << ", part: " << _part << endl;
    _part->setStart(_old);
cout << "ok" << endl;
  }
}

void MovePart::redo() {
  if (_part) {
cout << "new: " << _new << endl;
    _part->setStart(_new);
cout << "ok" << endl;
  }
}



// ---------------
// virtuals:
//

ostream & MovePart::print(int dep, ostream & s) {
  s << spc(dep) << "<MOVEPART part=\"" << _part << "\" old=\"" << _old << "\" new=\"" << _new << "\" />" << endl;
  return s;
}

void MovePart::flush(char * c) {
  cout << c << "MOVEPART" << endl;
}

Element * MovePart::copy() {
  return new MovePart(this);
}

  


#endif
