#ifndef _MOVEPART_H_
#define _MOVEPART_H_

#include "operation.h"
#include "position.h"

class Element;
class Compound;
class Part;

/** This operation moves a part to the position p
 */
class MovePart : public Operation
{
 private:
  Part * _part;
  Position _old;
  Position _new;
  
 public:
  MovePart(Position p, Part * pt);
  MovePart(MovePart*);
  ~MovePart();

  void undo();
  void redo();


  virtual ostream & print(int,ostream&);
  virtual void flush(char*);
  virtual Element * copy();
};



#endif
