#ifndef _OPERATION_H_
#define _OPERATION_H_

#include "atom.h"

class Operation : public Atoma
{
 protected:
  const char * _description;
  bool _to_be_undone;

 public:

  Operation();
  
  /**
   ** The destructor has definitely to be implemented:
   ** I.e. deleted notes, parts, tracks(!) have to be remembered in order
   ** to be able to undo the operation. Deleting the operation-object
   ** means to free the memory!
   **/
  virtual ~Operation();
  
  virtual void undo()=0;
  
  virtual void redo()=0;

  const char * description();

  bool isToBeUndone();

  void toBeUndone();

  virtual bool isEvent() { return false; }
};

#endif

