#ifndef _PASTESELECTION_CPP_
#define _PASTESELECTION_CPP_

#include <iostream.h>

#include "pasteSelection.h"
#include "element.h"
#include "compound.h"

#include "track.h"
#include "event.h"
#include "song.h"
#include "part.h"
#include "table.h"
#include "reference.h"

extern Song * sonG;
extern Table * selectionMemory;


PasteSelection::PasteSelection(Compound * pt, long pos) : _ins(new Table()), _comp(pt), _pos(pos) {
  _type = PASTESELECTION;
  _description = "paste selection";
  _to_be_undone = true;

  Element * ev = 0;
  long dpos = 0;
  Reference * fst = (Reference*) selectionMemory->first();
  if (fst!=0) {
    if (fst->getValue()->isEvent())   dpos = ((Event*) fst->getValue())->start() - _pos;
    if (fst->getValue()->isA()==PART) dpos = ((Part*) fst->getValue())->start() - _pos;
  }
  for (Reference * r = (Reference*)selectionMemory->first(); r != 0; r = (Reference*) Element::next(r)) {
    ev = r->getValue()->copy();
    if (dpos != 0) {
      if (ev->isEvent())   ((Event*)ev)->setStart(((Event*)ev)->start() - dpos);
      if (ev->isA()==PART) ((Part*)ev)->setStart(((Part*)ev)->start() - dpos);
    }
    _ins->add(new Reference(ev));
    _comp->add(ev);
    if (_comp->isTrack() && ev->isA()==PART) ((Part*)ev)->setTrack((Track*)_comp);
  }
  sonG->updateGui();
}


PasteSelection::PasteSelection(PasteSelection * el) {
  _type = PASTESELECTION;
  _comp = el->_comp;
  _pos  = el->_pos;
}

PasteSelection::~PasteSelection() {
  if (_ins!=0) {
    ((Compound*)_ins)->scratch(); // ??? doesn't he take the table's scratch-method ???
    delete _ins;
  }
}

void PasteSelection::undo() {
  for (Reference * r = (Reference*)_ins->first(); r != 0; r = (Reference*) Element::next(r)) {
    _comp->remove((Element*) r->getValue());
  }
  _ins->scratch();
  delete _ins;
  _ins = 0;
}

void PasteSelection::redo() {
  _ins = new Table();
  Element * ev = 0;
  long dpos = 0;
  Reference * fst = (Reference*) selectionMemory->first();
  if (fst!=0) {
    if (fst->getValue()->isEvent())   dpos = ((Event*) fst->getValue())->start() - _pos;
    if (fst->getValue()->isA()==PART) dpos = ((Part*) fst->getValue())->start() - _pos;
  }
  for (Reference * r = (Reference*)selectionMemory->first(); r != 0; r = (Reference*) Element::next(r)) {
    ev = r->getValue()->copy();
    if (dpos != 0) {
      if (ev->isEvent())   ((Event*)ev)->setStart(((Event*)ev)->start() - dpos);
      if (ev->isA()==PART) ((Part*)ev)->setStart(((Part*)ev)->start() - dpos);
    }
    _ins->add(new Reference(ev));
    _comp->add(ev);
    if (_comp->isTrack() && ev->isA()==PART) ((Part*)ev)->setTrack((Track*)_comp);
  }
  sonG->updateGui();
}



// ---------------
// virtuals:
//

ostream & PasteSelection::print(int dep, ostream & s) {
  s << spc(dep) << "<PASTESELECTION />" << endl;
  return s;
}

void PasteSelection::flush(char * c) {
  cout << c << "PASTESELECTION" << endl;
}

Element * PasteSelection::copy() {
  return new PasteSelection(this);
}

  


#endif
