#ifndef _POSITION_H_
#define _POSITION_H_

#include "atom.h"

class Song;
class Part;
class ostream;

class Position : public Atoma
{
 private:
  long totalTicks;
  int modulo(int);
  int Meter(int,Part*);
 public:
  Position();
  Position(long);
  Position(int,int,int,Part*,int m0=0,int m1=0);
  Position(int,int,int,int,int);
  Position(const Position&);
  Position(char*,Part*,int m0=0,int m1=0);
  long ticks();
  long negative();
  int gBar(Part*);
  int gBeat(Part*);
  int gTicks(Part*);
  int gBar(int,int);
  int gBeat(int,int);
  int gTicks(int,int);
  int gBar(Part*,int,int);
  int gBeat(Part*,int,int);
  int gTicks(Part*,int,int);
  void gBBT(int&,int&,int&,Part*,int&,int&,bool returnMeter=false);
  void nextBar(Part*,int,int);
  void nextBar(Song*);
  void prevBar(Part*,int,int);
  void prevBar(Song*);
  void snap(int);
  Position & operator=(const Position&);
  Position & operator=(long);
  Position & set(int,int,int,Part * master,int m0=0,int m1=0,int snap=0);
  Position & operator+=(Position);
  Position & operator-=(Position);
  double operator*(double);
  friend Position operator+(Position,Position);
  friend Position operator-(Position,Position);
  friend long operator+(Position,long);
  friend long operator-(Position,long);
  friend bool operator==(Position,Position);
  friend bool operator==(Position,long);
  friend bool operator!=(Position,Position);
  friend bool operator!=(Position,long);
  friend bool operator<(Position,Position);
  friend bool operator<=(Position,Position);
  friend bool operator>(Position,Position);
  friend bool operator>=(Position,Position);
  friend Position & operator++(Position&,int);
  friend ostream & operator<<(ostream&,Position&);

  virtual ostream & print(int,ostream&);
  virtual void flush(char*);
  virtual Element * copy();
  virtual bool isEvent() { return false; }


};


#endif
