#ifndef _PRFACTORY_H_
#define _PRFACTORY_H_

class PrMainEditor;
class PrTrack;
class PrPart;
class Track;
class Part;

class PrFactory
{
 private:
  static PrFactory * _factory;

 public:
  PrFactory() {};
  static void setFactory(PrFactory*);
  static PrFactory * factory();

  virtual char * isA()=0;
  virtual PrMainEditor * createMainEditor(int,char**)=0;
  virtual PrTrack * createScoreTrack(Track*)=0;
  virtual PrTrack * createDrumTrack(Track*)=0;
  virtual PrTrack * createMasterTrack(Track*)=0;
  virtual PrTrack * createAudioTrack(Track*)=0;
  virtual PrTrack * createCommentTrack(Track*)=0;
  virtual PrPart  * createPart(Part*)=0;
};


#endif
