#ifndef _PRSCOREEDITOR_CPP_
#define _PRSCOREEDITOR_CPP_

#include "prScoreEditor.h"
#include "table.h"
#include "part.h"
#include "track.h"
#include "reference.h"
#include "str.h"
#include "song.h"

extern Song * sonG;

enum { ID_TOOL_IN, ID_TOOL_ANS, ID_TOOL_AOS };

int sharpTab[] = { 0, 9, -3, 6, 15, 3, 12 }; 
int flatTab[] = { 12, 3, 15, 6, 18, 9, 0 };

int signShift[] = { 0, 6, 0, 0, 0, 6, 6, 12, 0, -6, 9, 3, -3, 0 };

int invFreq[] = { 58, 58, 57, 57, 56, 55, 55, 54, 54, 53, 53, 52, 51, 51, 50, 50, 49, 48, 48, 47, 47, 46, 46, 45, 44, 44, 43, 43, 42, 41, 41, 40, 40, 39, 39, 38, 37, 37, 36, 36, 35, 34, 34, 33, 33, 32, 32, 31, 30, 30, 29, 29, 28, 27, 27, 26, 26, 25, 25, 24, 23, 23, 22, 22, 21, 20, 20, 19, 19, 18, 18, 17, 16, 16, 15, 15, 14, 13, 13, 12, 12, 11, 11, 10, 9, 9, 8, 8, 7, 6, 6, 5, 5, 4, 4, 3, 2, 2, 1 ,1, 0 };

int sign[] = {  0,  1,  0,  1,  0,  0,  1,  0,  1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1,  0 , 1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1 , 0,  1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1,  0 , 1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1,  0 , 1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1,  0,  1,  0,  1,  0, 0, 1, 0 ,1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1 ,0, 1, 0, 0, 1, 0, 1, 0, 1, 0};

int enhF[5][12] = {
  { -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -2, -1 },
  {  0, -1,  0, -1, -1,  0, -1,  0, -1,  0, -1, -1 },
  {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },
  {  1,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0 },
  {  1,  1,  1,  0,  1,  1,  1,  1,  0,  1,  0,  1 }
};

int enhS[5][12] = {
  { -2, -1, -2, -2, -1, -2, -1, -2, -1, -2, -2, -1 },
  {  0, -1,  0, -1, -1,  0, -1,  0, -1,  0, -1, -1 },
  {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },
  {  1,  1,  0,  1,  0,  1,  1,  0,  1,  0,  1,  0 },
  {  1,  2,  2,  1,  2,  1,  2,  2,  1,  2,  1,  2 }
};

int yClef[] = { 0,-12,7,14,-7,-19,-26,-10,-14,-2,-4,-6,-8 };


int noteTab[] = { 'e', 'd', 'c', 'h', 'a', 'g', 'f' };
int freqTab[] = {100, 98, 96, 95, 93, 91, 89, 88, 86, 84, 83, 81, 79, 77, 76, 74, 72, 71, 69, 67, 65, 64, 62, 60, 59, 57, 55, 53, 52, 50, 48, 47, 45, 43, 41, 40, 38, 36, 35, 33, 31, 29, 28, 26, 24};

int scrSigns[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };

int allSigns[15][7] = {
 {-1, -1, -1, -1, -1, -1, -1 },
 {-1, -1, -1, -1, -1, -1,  0 },
 {-1, -1,  0, -1, -1, -1,  0 },
 {-1, -1,  0, -1, -1,  0,  0 },
 {-1,  0,  0, -1, -1,  0,  0 },
 {-1,  0,  0, -1,  0,  0,  0 },
 {0,   0,  0, -1,  0,  0,  0 },
 {0, 0, 0, 0, 0, 0, 0 },
 {0, 0, 0, 0, 0, 0, 1 },
 {0, 0, 1, 0, 0, 0, 1 },
 {0, 0, 1, 0, 0, 1, 1 },
 {0, 1, 1, 0, 0, 1, 1 },
 {0, 1, 1, 0, 1, 1, 1 },
 {1, 1, 1, 0, 1, 1, 1 },
 {1, 1, 1, 1, 1, 1, 1 }
};

const char * bClef2mClef[] = {"treble", "bass", "treble", "treble", "treble8", "bass", "bass", "bass", "bass", "soprano", "mezzosoprano", "alto", "tenor", "bass"};

const char * extNoteNames[] = {
  "nsStaccato", "nsLegato", "nsAccDown", "nsAccUp", "nsAccent1", "nsAccent2", "nsAccent3", "nsAccent4",
  "nsAccent5", "nsAccent6", "nsAccent7", "nsAccent8", "nsAccent9", "nsAccent10", "nsAccent11", "nsTriller",
  "nsTrill1", "nsTrill2", "nsInf", "nsBowUp", "nsBowDown" };

const char * auxScoreNames[] = {
  "asLabel1", "asLabel2", "asLabel3", "asCase1", "asCase2", "asPedal1", "asPedal2", "asNotedot",
  "asNote3", "asNote6", "asNotexx", "as8va", "as15va", "asTrillX", "asTrillX2", "asDecrescendo",
  "asCrescendo", "asBracketUp", "asBracketDown", "asArpeggio", "asText",
  "dynPPP", "dynPP", "dynP", "dynMP", "dynMF", "dynF",
  "dynFF", "dynFFF", "dynSFZ", "dynSF", "dynSFF", "dynFP" };




PrScoreEditor::PrScoreEditor()
  : PrPartEditor()
{

}

PrScoreEditor::PrScoreEditor(Part * p)
  : PrPartEditor(p)
{

}

PrScoreEditor::PrScoreEditor(Track * t)
  : PrPartEditor(t)
{

}

void PrScoreEditor::update() {

}

#endif
