#ifndef _KDEARRANGER_CPP_
#define _KDEARRANGER_CPP_

#include <iostream.h>

#include "klocale.h"

#include "kdeArranger.h"
#include "kdeScoreEditor.h"
#include "kdePianoRollEditor.h"
#include "kdeScoreTrack.h"
#include "kdeMainEditor.h"

#include "../../song.h"
#include "../../track.h"
#include "../../part.h"
#include "../../scoreTrack.h"
#include "../../addElement.h"
#include "../../prMainEditor.h"
#include "../../addon.h"

extern Song * sonG;
extern PrMainEditor * mainEditor;

#define ME ((KdeMainEditor*)mainEditor)

KdeArranger::KdeArranger(QWidget * parent, QPopupMenu * userDef)
  : QWidget(parent)
{
  /*
  char ** alist = ME->actionList();
  QPopupMenu * userDef = new QPopupMenu();
  for (int i=0;i<MAXACTIONS;i++) {
    // if ((alist[i]!=0) && (ME->actionContext(i)&Addon::TREAT_SONG)) userDef->insertItem(alist[i],i);
  }
  */
  // connect(userDef,SIGNAL(activated(int)),SLOT(slotAddon(int)));
  
  rbmenu = new QPopupMenu;
  rbmenu->connectItem( rbmenu->insertItem(i18n("Edit Pianoroll")), this, SLOT(slotEditPianoRoll()) );
  rbmenu->connectItem( rbmenu->insertItem(i18n("Edit Score")), this, SLOT(slotEditScore()) );
  rbmenu->insertSeparator();
  rbmenu->insertItem(i18n("User Addons"), userDef );
  
}

void KdeArranger::slotAddon(int i) {
  if (ME->actionList()[0] != 0) {
    ME->performAction( i, sonG );
  }
}

void KdeArranger::mousePressEvent(QMouseEvent * mouse) {
  if (mouse->button()==RightButton) {
    rbmenu->popup( mapToGlobal(mouse->pos()), 0 );
  }
}

void KdeArranger::mouseDoubleClickEvent(QMouseEvent * mouse) {
  int yy = mouse->y()/(1+ME->trackHeight())-1;
  Track * tr = (Track*) sonG->get(yy);
  if (tr==0) {
    tr = new ScoreTrack();
    sonG->doo(new AddElement(tr,sonG));
  }
  Part * pt = new Part(tr);
  sonG->doo(new AddElement(pt,tr));
  ME->update();
}

void KdeArranger::slotEditScore() {
  KdeScoreEditor * ev = new KdeScoreEditor();
  mainEditor->addEditor(ev);
  ev->KTMainWindow::show();
}

void KdeArranger::slotEditPianoRoll() {
  KdePianoRollEditor * ev = new KdePianoRollEditor();
  mainEditor->addEditor(ev);
  ev->KTMainWindow::show();
}

#endif
