#ifndef _KDEEDITORMENUBAR_CPP_
#define _KDEEDITORMENUBAR_CPP_

#include "kdeEditorMenuBar.h"
#include "resources.h"

#include <qpopupmenu.h>
#include <qaccel.h>
#include <qkeycode.h>

#include <klocale.h>


void KdeEditorMenuBar::createMenuBar(KMenuBar * menu, QPopupMenu * file, QPopupMenu * edit, QPopupMenu * snap, QPopupMenu * veloc, QPopupMenu * view) {

  file->insertItem( i18n("Settings"), ID_FILE_SETTINGS);
  file->insertItem( i18n("Print"), ID_EDIT_PRINT);
  file->insertSeparator();
  file->insertItem( i18n("Close"), ID_FILE_CLOSE);
  file->setAccel(ALT+Key_P,ID_EDIT_PRINT);
  file->setAccel(ALT+Key_W,ID_FILE_CLOSE);

  edit->insertItem( i18n("Undo"), ID_EDIT_UNDO );
  edit->insertItem( i18n("Redo"), ID_EDIT_REDO );
  edit->insertSeparator();
  edit->insertItem( i18n("Cut"), ID_EDIT_CUT);
  edit->insertItem( i18n("Copy"), ID_EDIT_COPY);
  edit->insertItem( i18n("Paste"), ID_EDIT_PASTE);
  edit->insertSeparator();
  edit->insertItem( i18n("Transpose"), ID_EDIT_TRANSPOSE);
  edit->insertSeparator();
  edit->insertItem( i18n("Quantize"), ID_EDIT_QUANTIZE_ALL);
  edit->insertItem( i18n("Length Quantize"), ID_EDIT_QUANTIZE_LENGTH);
  edit->insertItem( i18n("Fixed Length"), ID_EDIT_FIXED_LENGTH);
  edit->insertSeparator();
  edit->insertItem( i18n("Mark Left"), ID_EDIT_MARK_LEFT);
  edit->insertItem( i18n("Mark Right"), ID_EDIT_MARK_RIGHT);
  edit->insertItem( i18n("Unmark"), ID_EDIT_UNMARK);
  edit->insertSeparator();
  edit->insertItem( i18n("Erase"), ID_EDIT_CLEAR);

  edit->setAccel(ALT+Key_X,ID_EDIT_CUT);
  edit->setAccel(ALT+Key_C,ID_EDIT_COPY);
  edit->setAccel(ALT+Key_V,ID_EDIT_PASTE);
  edit->setAccel(Key_Escape,ID_EDIT_UNMARK);
  edit->setAccel(ALT+Key_Exclam,ID_EDIT_TRANSPOSE);
  edit->setAccel(ALT+Key_Q,ID_EDIT_QUANTIZE_ALL);
  edit->setAccel(ALT+Key_L,ID_EDIT_MARK_LEFT);
  edit->setAccel(ALT+Key_R,ID_EDIT_MARK_RIGHT);
  edit->setAccel(ALT+Key_Backspace,ID_EDIT_CLEAR);

  edit->setItemEnabled(ID_EDIT_CUT,FALSE);
  edit->setItemEnabled(ID_EDIT_COPY,FALSE);
  edit->setItemEnabled(ID_EDIT_PASTE,FALSE);
  edit->setItemEnabled(ID_EDIT_UNMARK,FALSE);
  edit->setItemEnabled(ID_EDIT_TRANSPOSE,FALSE);
  edit->setItemEnabled(ID_EDIT_QUANTIZE_ALL,FALSE);
  edit->setItemEnabled(ID_EDIT_QUANTIZE_LENGTH,FALSE);
  edit->setItemEnabled(ID_EDIT_FIXED_LENGTH,FALSE);

  /*
  snap->insertItem( loader->loadIcon( "n1",KIcon::Toolbar ), 1536 );
  snap->insertItem( loader->loadIcon( "n2",KIcon::Toolbar ), 768 );
  snap->insertItem( loader->loadIcon( "n4",KIcon::Toolbar ), 384 );
  snap->insertItem( loader->loadIcon( "n8",KIcon::Toolbar ), 192 );
  snap->insertItem( loader->loadIcon( "n16",KIcon::Toolbar ), 96 );
  snap->insertItem( loader->loadIcon( "n32",KIcon::Toolbar ), 48 );
  snap->insertItem( loader->loadIcon( "n64",KIcon::Toolbar ), 24 );*/


  snap->insertItem( i18n("1/1"), ID_GRID_1);
  snap->insertItem( i18n("1/2"), ID_GRID_2);
  snap->insertItem( i18n("1/4"), ID_GRID_4);
  snap->insertItem( i18n("1/8"), ID_GRID_8);
  snap->insertItem( i18n("1/16"), ID_GRID_16);
  snap->insertItem( i18n("1/32"), ID_GRID_32);
  snap->insertItem( i18n("1/64"), ID_GRID_64);
  snap->insertItem( i18n("Off"), ID_GRID_OFF);
  snap->setCheckable(TRUE);


  veloc->insertItem( i18n("Off "), 0);
  veloc->insertItem( i18n("ppp "), 14);
  veloc->insertItem( i18n("pp "), 28);
  veloc->insertItem( i18n("p "), 42);
  veloc->insertItem( i18n("mp "), 56);
  veloc->insertItem( i18n("mf "), 70);
  veloc->insertItem( i18n("f "), 86);
  veloc->insertItem( i18n("ff "), 102);
  veloc->insertItem( i18n("fff "), 127);
  veloc->setCheckable(true);

  view->setCheckable(true);
  view->insertItem(i18n("&Toolbar"), ID_VIEW_TOOLBAR);
  view->insertItem(i18n("&Notebar"), ID_VIEW_NOTEBAR);
  view->insertItem(i18n("&Buttonbar"), ID_VIEW_BUTTONBAR);
  view->insertItem(i18n("&Slider"), ID_VIEW_SLIDER);

  view->setAccel(ALT+Key_E,ID_VIEW_NOTEBAR);


  // menu = new KMenuBar( this );
  // CHECK_PTR( menu );
  menu->insertItem(i18n("File"),file);
  menu->insertItem(i18n("Edit"),edit);
  menu->insertItem(i18n("Grid"),snap);
  menu->insertItem(i18n("Dynamics"),veloc);
  menu->insertItem(i18n("View"),view);
  menu->show();



}


#endif
