#ifndef _KDEFACTORY_CPP_
#define _KDEFACTORY_CPP_

#include <dlfcn.h>                                                                                                                 
#include <iostream.h>

#include "../../prFactory.h"

#include "kdeMainEditor.h"
#include "kdeFactory.h"
#include "kdeScoreTrack.h"
#include "kdeDrumTrack.h"
#include "kdeMasterTrack.h"
#include "kdeAudioTrack.h"
#include "kdeCommentTrack.h"
#include "kdePart.h"

class KdeTrack;

extern "C" {
  PrFactory * libBrahmsKdePresentation() { return new KdeFactory(); }
}


char * KdeFactory::isA() {
  return "kde factory";
}

PrMainEditor * KdeFactory::createMainEditor(int argc, char** argv) {
  KApplication* brahms = new KApplication( argc, argv, "Brahms");
  KdeMainEditor * widget = new KdeMainEditor( "Brahms", brahms, argc, argv );
  brahms->setMainWidget( widget );
  return widget;
}

PrTrack * KdeFactory::createScoreTrack(Track * tr) {
  KdeTrack * kdetr = new KdeScoreTrack(tr);
  kdetr->show();
  return kdetr;
}

PrTrack * KdeFactory::createDrumTrack(Track * tr) {
  KdeTrack * kdetr = new KdeDrumTrack(tr);
  kdetr->show();
  return kdetr;
}

PrTrack * KdeFactory::createMasterTrack(Track * tr) {
  KdeTrack * kdetr = new KdeMasterTrack(tr);
  kdetr->show();
  return kdetr;
}

PrTrack * KdeFactory::createAudioTrack(Track * tr) {
  KdeTrack * kdetr = new KdeAudioTrack(tr);
  kdetr->show();
  return kdetr;
}

PrTrack * KdeFactory::createCommentTrack(Track * tr) {
  KdeTrack * kdetr = new KdeCommentTrack(tr);
  kdetr->show();
  return kdetr;
}

PrPart * KdeFactory::createPart(Part * pt) {
  KdePart * kdept = new KdePart(pt);
  kdept->show();
  return kdept;
}


#endif
