#ifndef _TIMEBAR_CPP_
#define _TIMEBAR_CPP_

#include <stdio.h>

#include <qpainter.h>

#include "../../song.h"
#include "../../part.h"
#include "../../prMainEditor.h"

#include "timeBar.h"
#include "kdeMainEditor.h"

extern Song * sonG;
extern PrMainEditor * mainEditor;

#define ME ((KdeMainEditor*)mainEditor)


TimeBar::TimeBar( QWidget *parent, const char *name )
  : QLabel( parent, name )
{
  setBackgroundMode( PaletteMidlight );
}

/*QtPartCanvas * TimeBar::gPartCanvas() {
  return pcanvas;
  }*/

void TimeBar::paintEvent( QPaintEvent * pe ) {

  master = sonG->master();
  met0 = sonG->meter0();
  met1 = sonG->meter1();


  QPixmap pix( width(), height() );    // for smooth display
  pix.fill( this, 2, 2 );             // paint in pixmap !
  QPainter painter;
  painter.begin( &pix );

  //QPainter painter;
  //painter.begin(this);

  painter.setPen(black);
  double pixPerTick = ME->pixPerTick();
  unsigned long xx;
  int beat;
  int bar;
  int tick;
  Position pos = Position(ME->barOffset()+1,1,0,master,met0,met1);
  int xoffset = 20 - int(pos.ticks()*1.0*pixPerTick);
  int xxx = width();
  Position add = Position(1,2,0,master,met0,met1); // one beat!
  char * txt = new char[12];
  bool draw = true;
  bool showNum;
  while (draw) {
    xx = pos.ticks();
    // cout << xx << "-" << met0 << ", " << met1 << ", " << pos.gBeat(master,met0,met1) << endl;
    xx = (long unsigned) (xx*pixPerTick + xoffset);
    pos.gBBT(bar,beat,tick,master,met0,met1);
    
    if (beat==1) {
      if (pixPerTick>0.0008) painter.drawLine(xx,16,xx,22);
      sprintf(txt,"%d ",bar);
      showNum = false;
      if (pixPerTick>0.015625) showNum = true;
      else if ((pixPerTick>0.0039) && ( (bar&3)==1 )) showNum = true;
      else if ((pixPerTick>0.0008) &&( (bar&15)==1 )) showNum = true;
      else if ((bar&127)==1) showNum = true;
      if (showNum) painter.drawText(xx+1,12,txt);
      if ((bar&7)==1) painter.drawLine(xx,12,xx,23);
    } else {
      if (pixPerTick>0.015625) painter.drawLine(xx,20,xx,22);
    }

    pos = pos + add;
    if (xx>(unsigned long) xxx) draw=false;
  }

  
  Position leftSel = sonG->left();
  Position rightSel = sonG->right();
  painter.setPen(red);
  xx = (long unsigned) (leftSel*pixPerTick+xoffset);
  painter.drawLine(xx,1,xx,22);
  painter.fillRect(xx,1,3,3,red);
  xx = (long unsigned) (rightSel*pixPerTick+xoffset);
  painter.drawLine(xx,1,xx,22);
  painter.fillRect(xx-3,1,3,3,red);
  
  
  painter.end();
  bitBlt( this, 0, 0, &pix );
  // painter.end();
  delete[] txt;

}

double TimeBar::gBarLength() {
  // return barlen;
  return 20;
}





#endif
