#ifndef _TYPECHOOSER_CPP_
#define _TYPECHOOSER_CPP_

#include <kiconloader.h>

#include <qpopupmenu.h>

#include "typeChooser.h"
#include "resources.h"
#include "kdeTrack.h"
#include "kdeMainEditor.h"

#include "../../track.h"
#include "../../convertTrack.h"
#include "../../song.h"
#include "../../prMainEditor.h"


extern Song * sonG;
extern PrMainEditor * mainEditor;
#define ME ((KdeMainEditor*)mainEditor)


TypeChooser::TypeChooser( QWidget * parent = 0, const char * name = 0 )
  : QLabel(parent,name), _track((KdeTrack*)parent)
{
  KIconLoader * loader = KGlobal::iconLoader();

  pmDrum = new QPixmap(loader->loadIcon( "drum", KIcon::Toolbar ));
  pmTime = new QPixmap(loader->loadIcon( "time", KIcon::Toolbar ));
  pmScor = new QPixmap(loader->loadIcon( "note", KIcon::Toolbar ));
  pmWave = new QPixmap(loader->loadIcon( "wav", KIcon::Toolbar ));
  pmComm = new QPixmap(loader->loadIcon( "comment", KIcon::Toolbar ));
  
  menu = new QPopupMenu;
  menu->setMouseTracking( TRUE );
  menu->connectItem( menu->insertItem(*pmScor,"Score Track",ID_SCORE), this, SLOT(chooseScore()) );
  menu->connectItem( menu->insertItem(*pmDrum,"Drum Track",ID_DRUM), this, SLOT(chooseDrum()) );
  menu->connectItem( menu->insertItem(*pmTime,"Mastertrack",ID_MASTER), this, SLOT(chooseMaster()) );
  menu->connectItem( menu->insertItem(*pmWave,"Audio Track",ID_AUDIO), this, SLOT(chooseWave()) );
  menu->connectItem( menu->insertItem(*pmComm,"Comment",ID_TEXT), this, SLOT(chooseComment()) );
  
  setAlignment(AlignCenter);
  update();
}

void TypeChooser::update() {
  switch (_track->track()->isA()) {
  case SCORETRACK: setPixmap(*pmScor); break;
  case DRUMTRACK: setPixmap(*pmDrum); break;
  case MASTERTRACK: setPixmap(*pmTime); break;
  case AUDIOTRACK: setPixmap(*pmWave); break;
  case COMMENTTRACK: setPixmap(*pmComm); break;
  }
}

void TypeChooser::mousePressEvent ( QMouseEvent * mouse ) {
  menu->popup( mapToGlobal(mouse->pos()), 0 );
}

void TypeChooser::chooseDrum() { sonG->doo(new ConvertTrack(1,_track->track(),sonG)); ME->update(); }

void TypeChooser::chooseMaster() { sonG->doo(new ConvertTrack(2,_track->track(),sonG)); ME->update(); }

void TypeChooser::chooseScore() { sonG->doo(new ConvertTrack(0,_track->track(),sonG)); ME->update(); }

void TypeChooser::chooseWave() { sonG->doo(new ConvertTrack(3,_track->track(),sonG)); ME->update(); }

void TypeChooser::chooseComment() { sonG->doo(new ConvertTrack(4,_track->track(),sonG)); ME->update(); }

/* wech
void TypeChooser::chooseDrum() { setPixmap(*pmDrum); _track->convertType(1); }

void TypeChooser::chooseMaster() { setPixmap(*pmTime); _track->convertType(2); }

void TypeChooser::chooseScore() { setPixmap(*pmScor); _track->convertType(0); }

void TypeChooser::chooseWave() { setPixmap(*pmWave); _track->convertType(3); }

void TypeChooser::chooseComment() { setPixmap(*pmComm); _track->convertType(4); }
*/

#endif
