#ifndef _SCORETRACK_H_
#define _SCORETRACK_H_

#include "track.h"

class ScoreTrack : public Track
{
 private:
  int _channel;
  int _program;
  int _output;
  int _volume;
  int _delay;
  int _transpose;

  bool _print_in_partiture;
  int _print_in_piano_system;

 public:
  ScoreTrack();
  ScoreTrack(ScoreTrack*);
  ~ScoreTrack();

  int channel();
  int program();
  int output();
  int volume();
  int delay();
  int transpose();

  void setChannel(int);
  void setProgram(int);
  void setOutput(int);
  void setVolume(int);
  void setDelay(int);
  void setTranspose(int);

  // virtual void hide();
  // virtual void show();

  virtual ostream & printOptions(int,ostream&);
  virtual void flush(char*);
  virtual Element * copy();

  void loadOpt(ifstream*&);

  /* for printing */

  /** Print-in-Partiture: returns true if this track is to be printed in a partiture */
  bool PiP();

  /** Print-in-Piano-System: returns where this track shall be printed within a piano system: 0=skip, 1=treble, 2=bass */
  int PiPS();

  /** sets the Print-in-Partiture flag */
  void sPiP(bool p);

  /** sets the Print-in-Piano-System position: 0=skip, 1=treble, 2=bass */
  void sPiPS(int p);

};

#endif
