#ifndef _STEM_CPP_
#define _STEM_CPP_

#include <iostream.h>
#include "stem.h"

Stem::Stem() : _stem(0) { _type = STEM; }

Stem::Stem(Stem * o) {
  _type = STEM;
  if (o) {
    _stem = o->_stem;
  }
}

void Stem::flip() {
  if (_stem==UP) _stem = DOWN;
  else _stem = UP;
}

int Stem::direction() { return _stem; }

bool Stem::up() { return (_stem==UP); }

bool Stem::down() { return (_stem==DOWN); }

void Stem::setDirection(int d) { _stem = d; }

void Stem::setUp() { _stem = UP; }

void Stem::setDown() { _stem = DOWN; }


// virtuals:


ostream & Stem::print(int dep, ostream & s) {
  s << spc(dep) << "<STEM value=\"";
  switch (_stem) {
  case UP: s << "UP"; break;
  case DOWN: s << "DOWN"; break;
  }
  s << "\" />" << endl;
  return s;
}

void Stem::flush(char * c) {
  cout << c << "STEM " << _stem << endl;

}

Element * Stem::copy() {
  return new Stem(this);
}

#endif
