#ifndef _SYMBOL_CPP_
#define _SYMBOL_CPP_

#include <iostream.h>
#include <stdio.h>
#include <string.h>

#include "symbol.h"
#include "note.h"

Symbol::Symbol( ) : _text(0), _displacement(0), _symbol(-1) {
  _type = SYMBOL;
}

Symbol::Symbol(Position p, int symbol) : Event(p,0), _text(0), _displacement(0), _symbol(symbol) {
  _type = SYMBOL;
}

Symbol::Symbol(Position p, int symbol, int displ) : Event(p,0), _text(0), _displacement(displ), _symbol(symbol) {
  _type = SYMBOL;
}

Symbol::Symbol(Position p, int symbol, int displ, int parameter) : Event(p,parameter), _text(0), _displacement(displ), _symbol(symbol) {
  _type = SYMBOL;
}

Symbol::Symbol(Position p, char * text) : Event(p,0), _text(text), _displacement(0), _symbol(AS_TEXT) {
  _type = SYMBOL;
}

Symbol::Symbol(Position p, char * text, int displ) : Event(p,0), _text(text), _displacement(displ), _symbol(AS_TEXT) {
  _type = SYMBOL;
}

Symbol::Symbol(Symbol * m) : Event(m) {
  _type = SYMBOL;
  if (m) {
    _symbol = m->_symbol;
    _displacement = m->_displacement;
    _text = m->_text;
  }
}

bool Symbol::isParameterized() {
  return (length()!=0);
}

bool Symbol::isText() {
  return (_text!=0);
}

int Symbol::symbol() {
  return _symbol;
}

int Symbol::displacement() {
  return _displacement;
}

char * Symbol::text() {
  return _text;
}

int Symbol::parameter() {
  return length();
}

void Symbol::setSymbol(int s) {
  _symbol = s;
}

void Symbol::setDisplacement(int d) {
  _displacement = d;
}

void Symbol::setText(char * t) {
  _text = strdup(t);
}

void Symbol::setParameter(int p) {
  setLength(p);
}


ostream & Symbol::print(int dep, ostream & s) {
  s << spc(dep) << "<SYMBOL pos=\"" << start().ticks() << "\" displacement=\"" << _displacement << "\" symbol=\"" << _symbol << "\" ";
  if (_text!=0) s << "text=\"" << _text << "\" ";
  if (length()!=0) s << "parameter=\"" << length() << "\" ";
  s << "/>" << endl;
  return s;
}

void Symbol::flush(char * c) {
  cout << c << "SYMBOL" << endl;
}

Element * Symbol::copy() {
  return new Symbol(this);
}






#endif
