#ifndef _SYMBOL_H_
#define _SYMBOL_H_

#include "event.h"

/** Instances of this class are symbols (or text-elements). They do not need a (graphical) presentation of their own. They can be displayed
 * graphically within the presentation of the parts, they belong to.
**/

class Symbol : public Event
{
 private:
  char * _text;
  int _displacement;
  int _symbol;

 public:
  Symbol( );
  Symbol(Position p, int symbol);
  Symbol(Position p, int symbol, int displ);
  Symbol(Position p, int symbol, int displ, int parameter);
  Symbol(Position p, char * text);
  Symbol(Position p, char * text, int displ);

  Symbol(Symbol*);

  bool isParameterized();
  bool isText();
  bool isSymbol();

  int symbol();
  int displacement();
  char * text();
  int parameter();

  void setSymbol(int);
  void setDisplacement(int);
  void setText(char*);
  void setParameter(int);
  virtual ostream & print(int,ostream&);
  virtual void flush(char*);
  virtual Element * copy();
};


#endif
