#ifndef _TRACK_H_
#define _TRACK_H_

#include "compound.h"

class String;
class PrTrack;

class Track : public Compound
{
 private:
  String * _name;
  bool _mute;
  bool _lock;

 protected:
  PrTrack * _pr;

 public:
  
  Track();
  Track(Track*,Type);
  ~Track();

  String * name();
  bool mute();
  bool lock();

  void setName(String*);
  void setName(char*);
  void setMute(bool);
  void setLock(bool);

  PrTrack * presentation();

  virtual void hide();
  virtual void show();

  virtual ostream & printOptions(int,ostream&)=0;

  virtual ostream & print(int,ostream&);
  virtual void flush(char*);
  virtual Element * copy()=0;

  static Element * load(char*,ifstream*&,Element*);

  virtual bool isTrack() { return true; }
};

#endif


